﻿Public Class Form1

    '*************************************************************
    ' 定数定義
    '*************************************************************

    Const s_cstTITLE As String = "印刷結果のＦＡＸ送信" 'メッセージボックスのタイトル用

    '*************************************************************
    ' 変数定義
    '*************************************************************

    Dim s_strFileName As String ' 印刷結果ファイル

    '*************************************************************
    ' プログラム起動
    '*************************************************************

    Private Sub Form1_Load(ByVal sender As Object, ByVal e As System.EventArgs) Handles Me.Load

        '-------------------------------------------------------------
        ' コマンドライン処理

        Dim strCommandLine As String

        s_strFileName = ""
        strCommandLine = Command()

        If strCommandLine = "" Then
            MsgBox("コマンドラインに印刷結果ファイルが指定されていません。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        ' コマンドラインからファイル名抽出
        '  ( ファイルパスのみ しか考慮していません。 )
        Dim strTempPath As String
        Dim iLen As Short

        strTempPath = strCommandLine

        ' 先頭の空白除去
        Do
            iLen = Len(strTempPath)
            If iLen = 0 Then
                Exit Do
            End If
            If Microsoft.VisualBasic.Left(strTempPath, 1) = Chr(32) Then
                strTempPath = Microsoft.VisualBasic.Right(strTempPath, iLen - 1)
            Else
                Exit Do
            End If
        Loop

        ' 後ろの空白除去
        Do
            iLen = Len(strTempPath)
            If iLen = 0 Then
                Exit Do
            End If
            If Microsoft.VisualBasic.Right(strTempPath, 1) = Chr(32) Then
                strTempPath = Microsoft.VisualBasic.Left(strTempPath, iLen - 1)
            Else
                Exit Do
            End If
        Loop

        ' ダブルコーテションを除去
        iLen = Len(strTempPath)
        If Microsoft.VisualBasic.Left(strTempPath, 1) = Chr(34) Then
            strTempPath = Microsoft.VisualBasic.Right(strTempPath, iLen - 1)
            iLen = Len(strTempPath)
            If Microsoft.VisualBasic.Right(strTempPath, 1) = Chr(34) Then
                strTempPath = Microsoft.VisualBasic.Left(strTempPath, iLen - 1)
            End If
            s_strFileName = strTempPath
        Else
            s_strFileName = strCommandLine
        End If

        If Dir(s_strFileName) = "" Then
            MsgBox("コマンドラインに指定された印刷結果ファイルが存在しません。", MsgBoxStyle.Critical, s_cstTITLE)
            s_strFileName = ""
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX インストール確認

        If AxSFCSEnv1.CheckInstall() <> SFCSENV_SUCCESS Then
            MsgBox("STARFAX がインストールされていない、" & vbCrLf & "もしくは STARFAX 環境設定プログラム でフォルダ環境が設定されていません。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サブフォルダ確認

        ' 送信命令フォルダ
        If AxSFCSEnv1.CheckSubFolder(SFCSENV_SMODE_SENDMIS) <> SFCSENV_SUCCESS Then
            MsgBox("送信命令フォルダが存在しません。" & vbCrLf & "STARFAX を１度起動することにより、" & vbCrLf & "送信命令フォルダが作成されます。", MsgBoxStyle.Critical, s_cstTITLE)
            Me.Close()
            End
        End If

        '/////////////////////////////////////////////////////////////
        '// STARFAX サービス状態取得

        If AxSFCSEnv1.CheckServiceStatus() = SFCSENV_SERVICE_STOP Then
            MsgBox("STARFAX が動作していないので、" & vbCrLf & "送信命令ファイルを作成しても、実際に送信動作は行われません。", MsgBoxStyle.Exclamation, s_cstTITLE)
        End If

        '-------------------------------------------------------------
        ' 印刷結果ファイル名表示

        TextFILE.Text = s_strFileName

    End Sub

    '*************************************************************
    ' プログラム終了
    '*************************************************************

    Private Sub Form1_FormClosed(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosedEventArgs) Handles Me.FormClosed

        ' 印刷結果ファイル 削除
        If s_strFileName <> "" Then
            Kill(s_strFileName)
            s_strFileName = ""
        End If

    End Sub

    '*************************************************************
    ' キャンセルボタン: クリック
    '*************************************************************

    Private Sub CommandCancel_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandCancel.Click

        ' 印刷結果ファイル 削除
        If s_strFileName <> "" Then
            Kill(s_strFileName)
            s_strFileName = ""
        End If

        End

    End Sub

    '*************************************************************
    ' ＦＡＸ送信ボタン: クリック
    '*************************************************************

    Private Sub CommandOK_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandOK.Click

        Dim lRet As Integer

        '-------------------------------------------------------------
        ' FAX番号

        If TextFAX.Text = "" Then
            MsgBox("FAX番号を指定してください", MsgBoxStyle.Exclamation, s_cstTITLE)
            Exit Sub
        End If

        '/////////////////////////////////////////////////////////////
        '// 送信命令ファイル作成
        '/////////////////////////////////////////////////////////////

        '-------------------------------------------------------------
        ' 相手先設定

        AxSFCSSendFax1.ResetSendInfo()
        lRet = AxSFCSSendFax1.AddSendInfo(TextFAX.Text, "", "", "", "", "", "", "", "", "", "", "", SFCSSENDFAX_SPEED_AUTO, SFCSSENDFAX_COMP_AUTO, SFCSSENDFAX_ECM_AUTO)
        If lRet <> SFCSSENDFAX_SUCCESS Then
            MsgBox("メモリエラーが発生しました", MsgBoxStyle.Critical, s_cstTITLE)
            Exit Sub
        End If

        '-------------------------------------------------------------
        ' 送信原稿設定

        AxSFCSSendFax1.ResetDocInfo()
        lRet = AxSFCSSendFax1.AddDocInfo(s_strFileName)
        If lRet <> SFCSSENDFAX_SUCCESS Then
            MsgBox("メモリエラーが発生しました", MsgBoxStyle.Critical, s_cstTITLE)
            Exit Sub
        End If
        ' STARFAX に印刷結果ファイルの削除を依頼します。
        AxSFCSSendFax1.SetDocInfoParam((SFCSSENDFAX_DOCPAPAME_DELETE))

        '-------------------------------------------------------------
        ' 送信命令ファイル作成
        '-------------------------------------------------------------

        lRet = AxSFCSSendFax1.MakeSendMission("", "", "", "")

        If lRet = SFCSSENDFAX_SUCCESS Then
            MsgBox("送信命令ファイルを作成しました。", MsgBoxStyle.OkOnly, s_cstTITLE)
        Else
            If lRet = SFCSSENDFAX_ERR_NoMisFolder Then
                MsgBox("送信命令フォルダが存在しません", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_GetMisFolder Then
                MsgBox("送信命令フォルダの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_GetTempFolder Then
                MsgBox("一時フォルダの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_GetTempFile Then
                MsgBox("一時ファイルの取得に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_MakeMisName Then
                MsgBox("送信命令ファイル名の作成に失敗しました", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_INFO Then
                MsgBox("パラメータエラー: 送信命令ファイル作成情報が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_SENDNUM Then
                MsgBox("パラメータエラー: 相手先数の指定が 0 です。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_SENDINFO Then
                MsgBox("パラメータエラー: 相手先情報が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_FAX Then
                MsgBox("パラメータエラー: FAX番号が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_DOCorCOVER Then
                MsgBox("パラメータエラー: 送信原稿ファイル、送付状ファイルが、ともに指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
            If lRet = SFCSSENDFAX_ERR_PARAM_DOCNAME Then
                MsgBox("パラメータエラー: 送信原稿ファイル名が指定されていません。", MsgBoxStyle.Exclamation, s_cstTITLE)
            End If
        End If

        ' 印刷結果ファイルは、STARFAX が削除します。
        s_strFileName = ""

        End

    End Sub

    '*************************************************************
    ' 表示ボタン: クリック
    '*************************************************************

    Private Sub CommandVIEW_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles CommandVIEW.Click

        Dim strViewExeName, strViewComand As Object
        Dim strViewPath As String
        Dim strInstall As String

        '/////////////////////////////////////////////////////////////
        '// ビューア呼び出し

        strInstall = New String(Chr(0), 161)

        If AxSFCSEnv1.GetSfcsFolder(strInstall) = SFCSENV_SUCCESS Then
            strViewExeName = "\SfCsVw.exe"
            strViewComand = " /Tビューア "
            strViewPath = Chr(34) & strInstall & strViewExeName & Chr(34) & strViewComand & Chr(34) & s_strFileName & Chr(34)
            Call Shell(strViewPath, AppWinStyle.NormalFocus)
        End If

    End Sub

End Class
