// ApiPrint.cpp :  STARFAX API
// 

#include "stdafx.h"
#include <winspool.h>

#include	"ApiPrint.h"

extern "C" {

/////////////////////////////////////////////////////////////////////////////
// 萔`

#define	SFCSPRT_PRINTERNAME	"MEGASOFT STARFAX Engine"

/////////////////////////////////////////////////////////////////////////////
// \̒`

#pragma pack(push,4)

// Ə
typedef struct _SFCSPRT_INFO {

	DWORD	m_dwMaxPrt;
	LPPRINTER_INFO_1	m_pPrtInfo1;
	LPPRINTER_INFO_2	m_pPrtInfo2;
	int	m_iPoi;

	HDC	m_hDc;

	BOOL	m_bChgPaper;
	WORD	m_wOldPaper;

}	SFCSPRT_INFO;

#pragma pack(pop)

/////////////////////////////////////////////////////////////////////////////
// ֐`

// F ؂芷
static BOOL	SUB_ChangeColor( char *pDevice, short sColor, short *psOldColor );
// pTCY ؂芷
static BOOL	SUB_ChangePaper( char *pDevice, WORD wSize, WORD *pwOldSize );

//**********************************************************************
// ֐        : SFCSPRT_Init
// @\          : STARFAX 
// Ăяo      : SFCSPRT_HANDLE APIENTRY SFCSPRT_Init( int *piError )
//           : piError = G[AG[擾p|C^
// o          : Ԓl  NULLȊO F nh
//               :       NULL     F G[
//               :                   *piError ... G[ ( SFCSPRT_STATUS_` )
// L      : STARFAX ̏s܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
SFCSPRT_HANDLE APIENTRY	SFCSPRT_Init( int *piError )
{
	SFCSPRT_HANDLE	hRet = (SFCSPRT_HANDLE)NULL;
	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)NULL;
	BOOL	bInit = FALSE;

	int	iDummy;

	if( piError == (int *)NULL ) {
		piError = &iDummy;
	}
	*piError = SFCSPRT_STATUS_PRTCREATE;

	// ƃ擾
	if( ( hRet = (SFCSPRT_HANDLE)HeapAlloc( GetProcessHeap(), 0, sizeof(SFCSPRT_INFO) ) ) == (SFCSPRT_HANDLE)NULL ) {
		*piError = SFCSPRT_STATUS_MEMORY;
		return( hRet );
	}

	// ݒ
	pInfo = (SFCSPRT_INFO *)hRet;
	ZeroMemory( (LPVOID)pInfo, sizeof(SFCSPRT_INFO) );

	{

		DWORD	dwBytesNeeded;
		DWORD	dwPrtRet1, dwPrtRet2;
		LPTSTR	lpName = NULL;
		DWORD	gdwEnumFlags = PRINTER_ENUM_FAVORITE | PRINTER_ENUM_LOCAL;

		//
		// get byte count needed for buffer, alloc buffer, the enum the printers
		//
		EnumPrinters( gdwEnumFlags, lpName, 1, NULL, 0, &dwBytesNeeded, &dwPrtRet1 );

		//
		// (simple error checking, if these work assume rest will too)
		//
		if( !( pInfo->m_pPrtInfo1 = (LPPRINTER_INFO_1) LocalAlloc( LPTR, dwBytesNeeded ) ) ) {
			goto	EXIT;
		}
		if( !EnumPrinters( gdwEnumFlags, lpName, 1, (LPBYTE) pInfo->m_pPrtInfo1, dwBytesNeeded, &dwBytesNeeded, &dwPrtRet1 ) ) {
			goto	EXIT;
		}

		//
		// If we don't get any printers from the Level == 1 call, there is
		//  no point in continuing... report it, free memory, and return.
		//
		if( dwPrtRet1 == 0 ) {
			goto	EXIT;
		}

		//
		// Call EnumPrinters again with Level == 2.
		//
		// get byte count needed for buffer, alloc buffer, the enum the printers
		//
		EnumPrinters( gdwEnumFlags, lpName, 2, NULL, 0, &dwBytesNeeded, &dwPrtRet2 );
		pInfo->m_pPrtInfo2 = (LPPRINTER_INFO_2) LocalAlloc( LPTR, dwBytesNeeded );
		EnumPrinters( gdwEnumFlags, lpName, 2, (LPBYTE) pInfo->m_pPrtInfo2, dwBytesNeeded, &dwBytesNeeded, &dwPrtRet2 );

		//
		// Calling EnumPrinters with Level == 2 frequently returns 0 printers.
		//  If so display only the PRINTER_INFO_1 structures we got before.
		//
		if( dwPrtRet2 == 0 ) {
			pInfo->m_dwMaxPrt = dwPrtRet1;
			pInfo->m_pPrtInfo2 = NULL;
		}
		else {
			pInfo->m_dwMaxPrt = dwPrtRet1 > dwPrtRet2 ? dwPrtRet2 : dwPrtRet1;
		}

		*piError = SFCSPRT_STATUS_NOSFCS;
		for( pInfo->m_iPoi = 0 ; pInfo->m_iPoi < (int)pInfo->m_dwMaxPrt ; pInfo->m_iPoi++ ) {
			if( !lstrcmp( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, SFCSPRT_PRINTERNAME ) ) {
				bInit = TRUE;
				*piError = SFCSPRT_STATUS_SUCCSESS;
				break;
			}
		}
	}

EXIT:

	if( !bInit ) {
		SFCSPRT_Term( hRet );
		hRet = (SFCSPRT_HANDLE)NULL;
	}

	return( hRet );
}

//**********************************************************************
// ֐        : SFCSPRT_Term
// @\          : STARFAX I
// Ăяo      : void APIENTRY SFCSPRT_Term( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  Ȃ
// L      : STARFAX ̏Is܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
void APIENTRY	SFCSPRT_Term( SFCSPRT_HANDLE hHdl )
{
	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		return;
	}

	// n
	if( pInfo->m_hDc != (HDC)NULL ) {
		DeleteDC( pInfo->m_hDc );
		pInfo->m_hDc = (HDC)NULL;
	}
	if( pInfo->m_bChgPaper ) {
		SUB_ChangePaper( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, pInfo->m_wOldPaper, (WORD *)NULL );
		pInfo->m_bChgPaper = FALSE;
	}
	if( pInfo->m_pPrtInfo2 ) {
		LocalFree( LocalHandle ( pInfo->m_pPrtInfo2 ) );
		pInfo->m_pPrtInfo2 = (LPPRINTER_INFO_2)NULL;
	}
	if( pInfo->m_pPrtInfo1 ) {
		LocalFree( LocalHandle ( pInfo->m_pPrtInfo1 ) );
		pInfo->m_pPrtInfo1 = (LPPRINTER_INFO_1)NULL;
	}

	HeapFree( GetProcessHeap(), 0, (LPVOID)hHdl );
}

//**********************************************************************
// ֐        : SFCSPRT_StartDoc
// @\          : STARTDOC 
// Ăяo      : HDC APIENTRY SFCSPRT_StartDoc( SFCSPRT_HANDLE hHdl, char *pDoc, DWORD dwPaper, int *piError )
//           : hHdl    = nh
//               : pDoc    = hLg
//               : dwPaper = pTCY w
//               : 
//               :                                     ( 0x00000000 ) ... w薳
//               :           SFCSPRT_PAPER_A4          ( 0x00000001 ) ... A4
//               :           SFCSPRT_PAPER_B4          ( 0x00000002 ) ... B4
//               :           SFCSPRT_PAPER_A3          ( 0x00000004 ) ... A3
//               :           SFCSPRT_PAPER_A5          ( 0x00000008 ) ... A5
//               :           SFCSPRT_PAPER_B5          ( 0x00000010 ) ... B5
//               :           SFCSPRT_PAPER_LETTER      ( 0x00000020 ) ... ^[
//               :           SFCSPRT_PAPER_LEGAL       ( 0x00000040 ) ... [K
//               :           SFCSPRT_PAPER_TABLOID     ( 0x00000080 ) ... ^uCh
//               :           SFCSPRT_PAPER_STATEMENT   ( 0x00000100 ) ... Xe[gg
//               : 
//               : piError = G[AG[擾p|C^
// o          : Ԓl  NULLȊO F foCXReLXg̃nh
//               :       NULL     F G[
//               :                   *piError ... G[ ( SFCSPRT_STATUS_` )
// L      : Jn܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
HDC APIENTRY	SFCSPRT_StartDoc( SFCSPRT_HANDLE hHdl, char *pDoc, DWORD dwPaper, int *piError )
{
	HDC	hRet = (HDC)NULL;

	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	int	iDummy;

	if( piError == (int *)NULL ) {
		piError = &iDummy;
	}
	*piError = SFCSPRT_STATUS_PRTCREATE;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		*piError = SFCSPRT_STATUS_PRTCREATE;
		goto	EXIT;
	}

	if( pInfo->m_hDc != (HDC)NULL ) {
		DeleteDC( pInfo->m_hDc );
		pInfo->m_hDc = (HDC)NULL;
	}

	// pTCYݒ
	if( dwPaper ) {
		// ݒ\pTCY mF
		if( SFCSPRT_CheckPaper( hHdl ) & dwPaper ) {

			WORD	wSize;

			switch( dwPaper ) {
			case	SFCSPRT_PAPER_A4:			wSize = DMPAPER_A4;			break;
			case	SFCSPRT_PAPER_B4:			wSize = DMPAPER_B4;			break;
			case	SFCSPRT_PAPER_A3:			wSize = DMPAPER_A3;			break;
			case	SFCSPRT_PAPER_A5:			wSize = DMPAPER_A5;			break;
			case	SFCSPRT_PAPER_B5:			wSize = DMPAPER_B5;			break;
			case	SFCSPRT_PAPER_LETTER:		wSize = DMPAPER_LETTER;		break;
			case	SFCSPRT_PAPER_LEGAL:		wSize = DMPAPER_LEGAL;		break;
			case	SFCSPRT_PAPER_TABLOID:	wSize = DMPAPER_TABLOID;	break;
			case	SFCSPRT_PAPER_STATEMENT:	wSize = DMPAPER_STATEMENT;	break;
			default:
				wSize = DMPAPER_A4;
				break;
			}
			pInfo->m_bChgPaper = SUB_ChangePaper( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, wSize, &pInfo->m_wOldPaper );
		}
	}

    pInfo->m_hDc = CreateDC( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pDriverName, (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPortName, NULL );
	if( pInfo->m_hDc != (HDC)NULL ) {

	    DOCINFO	di;

		di.cbSize = sizeof(DOCINFO);
		di.lpszDocName = pDoc;
		di.lpszOutput = (LPTSTR)NULL;
		di.lpszDatatype = (LPTSTR)NULL;
		di.fwType = 0;

		if( StartDoc( pInfo->m_hDc, &di ) > 0 ) {
			hRet = pInfo->m_hDc;
			*piError = SFCSPRT_STATUS_SUCCSESS;
		}
		else {
			DeleteDC( pInfo->m_hDc );
			pInfo->m_hDc = (HDC)NULL;
		}
	}

EXIT:
	
	return hRet;
}

//**********************************************************************
// ֐        : SFCSPRT_StartPage
// @\          : STARTPAGE 
// Ăяo      : BOOL APIENTRY SFCSPRT_StartPage( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  TRUE  F 
//               :       FALSE F s
// L      : y[WJn܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
BOOL APIENTRY	SFCSPRT_StartPage( SFCSPRT_HANDLE hHdl )
{
	DWORD	bRet = FALSE;

	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		goto	EXIT;
	}
	if( pInfo->m_hDc == (HDC)NULL ) {
		goto	EXIT;
	}
	if( StartPage( pInfo->m_hDc ) > 0 ) {
		bRet = TRUE;
	}

EXIT:
	
	return bRet;
}

//**********************************************************************
// ֐        : SFCSPRT_EndPage
// @\          : ENDPAGE 
// Ăяo      : BOOL APIENTRY SFCSPRT_EndPage( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  TRUE  F 
//               :       FALSE F s
// L      : y[WI܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
BOOL APIENTRY	SFCSPRT_EndPage( SFCSPRT_HANDLE hHdl )
{
	DWORD	bRet = FALSE;

	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		goto	EXIT;
	}
	if( pInfo->m_hDc == (HDC)NULL ) {
		goto	EXIT;
	}
	if( EndPage( pInfo->m_hDc ) > 0 ) {
		bRet = TRUE;
	}

EXIT:
	
	return bRet;
}

//**********************************************************************
// ֐        : SFCSPRT_EndDoc
// @\          : ENDDOC 
// Ăяo      : void APIENTRY SFCSPRT_EndDoc( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  TRUE  F 
//               :       FALSE F s
// L      : I܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
void APIENTRY	SFCSPRT_EndDoc( SFCSPRT_HANDLE hHdl )
{
	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		goto	EXIT;
	}

	if( pInfo->m_hDc != (HDC)NULL ) {
		EndDoc( pInfo->m_hDc );
		DeleteDC( pInfo->m_hDc );
		pInfo->m_hDc = (HDC)NULL;
	}
	if( pInfo->m_bChgPaper ) {
		SUB_ChangePaper( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, pInfo->m_wOldPaper, (WORD *)NULL );
		pInfo->m_bChgPaper = FALSE;
	}

EXIT:
	
	return;
}

//**********************************************************************
// ֐        : SFCSPRT_AbortDoc
// @\          : ABORTDOC 
// Ăяo      : void APIENTRY SFCSPRT_AbortDoc( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  TRUE  F 
//               :       FALSE F s
// L      : 𒆒f܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
void APIENTRY	SFCSPRT_AbortDoc( SFCSPRT_HANDLE hHdl )
{
	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		goto	EXIT;
	}

	if( pInfo->m_hDc != (HDC)NULL ) {
		AbortDoc( pInfo->m_hDc );
		DeleteDC( pInfo->m_hDc );
		pInfo->m_hDc = (HDC)NULL;
	}
	if( pInfo->m_bChgPaper ) {
		SUB_ChangePaper( (pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName, pInfo->m_wOldPaper, (WORD *)NULL );
		pInfo->m_bChgPaper = FALSE;
	}

EXIT:
	
	return;
}

//**********************************************************************
// ֐        : SFCSPRT_CheckPaper
// @\          : ݒ\pTCY mF
// Ăяo      : DWORD APIENTRY SFCSPRT_CheckPaper( SFCSPRT_HANDLE hHdl )
//           : hHdl = nh
// o          : Ԓl  pTCY
//               : 
//               :         SFCSPRT_PAPER_A4         ( 0x00000001 ) ... A4
//               :         SFCSPRT_PAPER_B4         ( 0x00000002 ) ... B4
//               :         SFCSPRT_PAPER_A3         ( 0x00000004 ) ... A3
//               :         SFCSPRT_PAPER_A5         ( 0x00000008 ) ... A5
//               :         SFCSPRT_PAPER_B5         ( 0x00000010 ) ... B5
//               :         SFCSPRT_PAPER_LETTER     ( 0x00000020 ) ... ^[
//               :         SFCSPRT_PAPER_LEGAL      ( 0x00000040 ) ... [K
//               :         SFCSPRT_PAPER_TABLOID    ( 0x00000080 ) ... ^uCh
//               :         SFCSPRT_PAPER_STATEMENT  ( 0x00000100 ) ... Xe[gg
//               : 
// L      : ݒ\ȗpTCYmF܂B
// 쐬        : 
// 쐬        : 2005.06.28
//**********************************************************************
DWORD APIENTRY	SFCSPRT_CheckPaper( SFCSPRT_HANDLE hHdl )
{
	DWORD	dwRet = 0;

	SFCSPRT_INFO	*pInfo = (SFCSPRT_INFO *)hHdl;

	DWORD	dwWRet = FALSE;
	WORD	*pwPaper = (WORD *)NULL;

	int	i;

	if( hHdl == (SFCSPRT_HANDLE)NULL ) {
		goto	EXIT;
	}

	dwWRet = DeviceCapabilities(
		(pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName,	//  v^\ւ̃|C^
		(pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPortName,	//  |[g\ւ̃|C^
		DC_PAPERS,											//  擾foCX̔\
		NULL,												//  o͐̃AhX
		NULL												//  foCXf[^\̂ւ̃|C^
	);
	if( dwWRet == 0xffffffff ) {
		goto	EXIT;
	}
	pwPaper = new WORD[dwWRet];
	if( !pwPaper ) {
		goto	EXIT;
	}
	dwWRet = DeviceCapabilities(
		(pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPrinterName,	//  v^\ւ̃|C^
		(pInfo->m_pPrtInfo2 + pInfo->m_iPoi)->pPortName,	//  |[g\ւ̃|C^
		DC_PAPERS,											//  擾foCX̔\
		(char *)pwPaper,									//  o͐̃AhX
		NULL												//  foCXf[^\̂ւ̃|C^
	);
	if( dwWRet == 0xffffffff ) {
		goto	EXIT;
	}
	for( i = 0 ; i < (int)dwWRet ; i++ ) {
		if( pwPaper[i] == DMPAPER_A4 ) {
			dwRet |= SFCSPRT_PAPER_A4;
		}
		else if( pwPaper[i] == DMPAPER_B4 ) {
			dwRet |= SFCSPRT_PAPER_B4;
		}
		else if( pwPaper[i] == DMPAPER_A3 ) {
			dwRet |= SFCSPRT_PAPER_A3;
		}
		else if( pwPaper[i] == DMPAPER_A5 ) {
			dwRet |= SFCSPRT_PAPER_A5;
		}
		else if( pwPaper[i] == DMPAPER_B5 ) {
			dwRet |= SFCSPRT_PAPER_B5;
		}
		else if( pwPaper[i] == DMPAPER_LETTER ) {
			dwRet |= SFCSPRT_PAPER_LETTER;
		}
		else if( pwPaper[i] == DMPAPER_LEGAL ) {
			dwRet |= SFCSPRT_PAPER_LEGAL;
		}
		else if( pwPaper[i] == DMPAPER_TABLOID ) {
			dwRet |= SFCSPRT_PAPER_TABLOID;
		}
		else if( pwPaper[i] == DMPAPER_STATEMENT ) {
			dwRet |= SFCSPRT_PAPER_STATEMENT;
		}
	}

EXIT:

	if( pwPaper ) {
		delete pwPaper;
	}

	return dwRet;
}

/////////////////////////////////////////////////////////////////////////////
// pTCY ؂芷
// 
// 쐬        : 
// 

static BOOL	SUB_ChangePaper( char *pDevice, WORD wSize, WORD *pwOldSize )
{
	BOOL	bRet = FALSE;
	HANDLE	hPrinter = (HANDLE)NULL;
	PRINTER_DEFAULTS	PrnDef;
	DWORD	dwSize = 0;

	PRINTER_INFO_2	*pInfo2 = (PRINTER_INFO_2 *)NULL;

	DEVMODE	*pDevMode = (DEVMODE *)NULL;

	pInfo2 = (PRINTER_INFO_2 *)NULL;
	ZeroMemory( &PrnDef, sizeof(PRINTER_DEFAULTS) );
	PrnDef.DesiredAccess = PRINTER_ALL_ACCESS;

	bRet = OpenPrinter(
		pDevice,		// v^A܂̓vgT[o[ւ̃|C^
		&hPrinter,		// v^܂̓vgT[o[̃nhւ̃|C^
		&PrnDef			// v^̃ftHg̍\̂ւ̃|C^
	);
	if( !bRet ) {
		goto	EXIT;
	}

	bRet = GetPrinter(
		hPrinter,	// Ώۂ̃v^ʂnh
		2,			// v^f[^\̂̃o[W
		NULL,		// v^\̂󂯎oCgzւ̃|C^
		0,			// pPrinter wobt@̃TCY (oCg)
		&dwSize		// 擾 (Kv) oCg󂯎ϐւ̃|C^
	);

	pInfo2 = (PRINTER_INFO_2 *)( new char[dwSize] );
	if( !pInfo2 ) {
		goto	EXIT;
	}

	bRet = GetPrinter(
		hPrinter,			// Ώۂ̃v^ʂnh
		2,					// v^f[^\̂̃o[W
		(unsigned char *)pInfo2,	// v^\̂󂯎oCgzւ̃|C^
		dwSize,				// pPrinter wobt@̃TCY (oCg)
		&dwSize				// 擾 (Kv) oCg󂯎ϐւ̃|C^
	);
	if( !bRet ) {
		goto	EXIT;
	}

	if( !pInfo2->pDevMode ) {
		goto	EXIT;
	}

	if( pInfo2->pDevMode->dmFields & DM_PAPERSIZE ) {

		if( pwOldSize ) {
			*pwOldSize = pInfo2->pDevMode->dmPaperSize;
		}
		pInfo2->pDevMode->dmPaperSize = wSize;

        DocumentProperties( NULL, hPrinter, pDevice, pInfo2->pDevMode, pInfo2->pDevMode, DM_IN_BUFFER | DM_OUT_BUFFER );

		bRet = SetPrinter(
			hPrinter,		// v^IuWFNgʂnh
			2,				// \̂̃x
			(unsigned char *)pInfo2,		// v^̃f[^i[Ăzւ̃|C^
			0				// v^̏Ԃݒ肷R}h
		);

		goto	EXIT;
	}

	bRet = FALSE;

EXIT:

	if( hPrinter ) {
		ClosePrinter( hPrinter );
	}
	if( pDevMode ) {
		delete (char *)pDevMode;
	}
	if( pInfo2 ) {
		delete ( pInfo2 );
	}

	return bRet;
}

/////////////////////////////////////////////////////////////////////////////
// F ؂芷
// 
// 쐬        : 
// 

static BOOL	SUB_ChangeColor( char *pDevice, short sColor, short *psOldColor )
{
	BOOL	bRet = FALSE;
	HANDLE	hPrinter = (HANDLE)NULL;
	PRINTER_DEFAULTS	PrnDef;
	DWORD	dwSize = 0;

	PRINTER_INFO_2	*pInfo2 = (PRINTER_INFO_2 *)NULL;

	DEVMODE	*pDevMode = (DEVMODE *)NULL;

	pInfo2 = (PRINTER_INFO_2 *)NULL;
	ZeroMemory( &PrnDef, sizeof(PRINTER_DEFAULTS) );
	PrnDef.DesiredAccess = PRINTER_ALL_ACCESS;

	bRet = OpenPrinter(
		pDevice,		// v^A܂̓vgT[o[ւ̃|C^
		&hPrinter,		// v^܂̓vgT[o[̃nhւ̃|C^
		&PrnDef			// v^̃ftHg̍\̂ւ̃|C^
	);
	if( !bRet ) {
		goto	EXIT;
	}

	bRet = GetPrinter(
		hPrinter,	// Ώۂ̃v^ʂnh
		2,			// v^f[^\̂̃o[W
		NULL,		// v^\̂󂯎oCgzւ̃|C^
		0,			// pPrinter wobt@̃TCY (oCg)
		&dwSize		// 擾 (Kv) oCg󂯎ϐւ̃|C^
	);

	pInfo2 = (PRINTER_INFO_2 *)( new char[dwSize] );
	if( !pInfo2 ) {
		goto	EXIT;
	}

	bRet = GetPrinter(
		hPrinter,			// Ώۂ̃v^ʂnh
		2,					// v^f[^\̂̃o[W
		(unsigned char *)pInfo2,	// v^\̂󂯎oCgzւ̃|C^
		dwSize,				// pPrinter wobt@̃TCY (oCg)
		&dwSize				// 擾 (Kv) oCg󂯎ϐւ̃|C^
	);
	if( !bRet ) {
		goto	EXIT;
	}

	if( !pInfo2->pDevMode ) {
		goto	EXIT;
	}

	if( pInfo2->pDevMode->dmFields & DM_COLOR ) {

		if( psOldColor ) {
			*psOldColor = pInfo2->pDevMode->dmColor;
		}
		pInfo2->pDevMode->dmColor = sColor;

        DocumentProperties( NULL, hPrinter, pDevice, pInfo2->pDevMode, pInfo2->pDevMode, DM_IN_BUFFER | DM_OUT_BUFFER );

		bRet = SetPrinter(
			hPrinter,		// v^IuWFNgʂnh
			2,				// \̂̃x
			(unsigned char *)pInfo2,		// v^̃f[^i[Ăzւ̃|C^
			0				// v^̏Ԃݒ肷R}h
		);

		goto	EXIT;
	}

	bRet = FALSE;

EXIT:

	if( hPrinter ) {
		ClosePrinter( hPrinter );
	}
	if( pDevMode ) {
		delete (char *)pDevMode;
	}
	if( pInfo2 ) {
		delete ( pInfo2 );
	}

	return bRet;
}

}
